<?php
class actionBooksmanagerAddChapter extends cmsAction {

    public function run(){

        $item_id = $this->request->get('item_id', false);
        $title = $this->request->get('title', false);
        $content = $this->request->get('content', false);
        $author_id = $this->request->get('author', false);
        $chapter_id = $this->request->get('chapter_id', false);

        $user = cmsUser::getInstance();
        if(!$author_id) $author_id = $user->id;
        if(!$chapter_id) $chapter_id = md5(time());

        if(!$title || !$content) return $this->cms_template->renderJSON(array(
            'error'   => true,
            'message' => 'Неверные параметры запроса!'
        ));

        $book_item = cmsCore::getModel('content')->getContentItem($this->options['ctype'], $item_id);

        if(!$this->allowThisBook($user, $book_item)) return $this->cms_template->renderJSON(array(
            'error'   => true,
            'message' => 'У вас нет прав на изменение данной книги!'
        ));

        $book = $this->getBookByParent($item_id);
        if(!$book) $book = $this->createBook($book_item, $user);

        if(!$this->addChapter($book['name'], $chapter_id, $content)) return $this->cms_template->renderJSON(array(
            'error'   => true,
            'message' => 'Не удалось записать главу! Проверьте права на запись.'
        ));

        if(!is_array($book['chapters'])) $book['chapters'] = array();
        if(!isset($book['chapters'][$chapter_id])) $book['chapters'][$chapter_id] = array();
        $content = preg_replace('/[\x{200B}-\x{200D}\x{FEFF}]/u', '', $content);

        $book['chapters'][$chapter_id]['title'] = $title;
        $book['chapters'][$chapter_id]['filename'] = $chapter_id.'.txt';
        $book['chapters'][$chapter_id]['symbols'] = mb_strlen(strip_tags($content));

        $book['chapters'][$chapter_id]['last_modified'] = date("Y-m-d H:i:s", time());
        if(!isset($book['chapters'][$chapter_id]['date_pub'])){
            $book['chapters'][$chapter_id]['date_pub'] = $book['chapters'][$chapter_id]['last_modified'];
        }

        $book['symbols'] = $this->calcBookSymbols($book);
        $book['last_modified'] = date("Y-m-d H:i:s", time());
        if(!isset($book['date_pub'])) $book['date_pub'] = $book['last_modified'];

        $this->model->update('booksmanager', $book['id'], $book);

        return $this->cms_template->renderJSON(array(
            'error'   => false,
            'message' => $this->getChaptersHtml($book),
            'book_id' => $book['id'],
            'chapter_id' => $chapter_id
        ));

    }

}
