<?php if ($field->title) { ?><label for="<?php echo $field->id; ?>"><?php echo $field->title; ?></label><?php } ?>

<?php
$item_id = isset($field->item['id']) ? $field->item['id'] : 'none';
$author_id = isset($field->item['user']['id']) ? $field->item['user']['id'] : cmsUser::getInstance()->id;
echo html_input('hidden', 'book-item-id', $item_id, array('id'=>'book-item-id'));
echo html_input('hidden', 'book-author-id', $author_id, array('id'=>'book-author-id'));
echo html_input('hidden', 'book-chapter-id', '', array('id'=>'book-chapter-id'));
?>
<div class="main-book">
    <div class="book-chapters-manager"><?php echo $field->manager->getChaptersHtml($field->book); ?></div>

    <div class="book-chapter-content field">
        <div class="add-chapter">
            <label for="book-chapter-title">Название главы</label>
            <?php echo html_input('string', 'book-chapter-title', '', array('id'=>'book-chapter-title', 'required'=>false)); ?>
            <label for="book-chapter-text">Текст главы</label>
            <?php echo html_wysiwyg('book-chapter-text', '', $field->getOption('editor')); ?>
            <div class="book-save-chapter book-btn" rel="add" onclick="saveChapter(); return false;">Сохранить</div>
            <div class="book-cancel-chapter book-btn" rel="add" onclick="cancelChapter(); return false;">Отменить</div>
        </div>
    </div>

    <div style="clear: both;"></div>

<div class="modal">
    <div class="modal-body">
        <div class="modal-title">
            <span></span>
            <div class="modal-close" onclick="hideModal();">Закрыть</div>
            </div>
        <div class="modal-content"></div>
        <div class="modal-buttons"></div>
    </div>
</div>

<script>

    to_del = [];
    need_save = 0;
    $('input#del-flag').each(function () {
        if ($(this).is(':checked')) {
            to_del.push($(this).val());
			$(this).closest('div.book-chapter').addClass('select');
        } else {
			$(this).closest('div.book-chapter').removeClass('select');
		}
    });

    if(to_del.length > 0){
        $('div.selected-delete').addClass('active');
    }

    function addChapter(){
        $('#book-chapter-id').val('');
        $('div.book-chapter-content').slideDown(0);
        $('html, body').animate({
            scrollTop: $('div.book-chapter-content').offset().top
        }, 0);
        $('#edit_book_menu').hide();
        $('div.book-chapters-manager').hide();
        $('div.book-chapters').hide();
        $('div.book-add-chapter').hide();
        $('div.selected-delete').hide();
        $('div.header-chapters').hide();
        $('div.book-cancel-chapter').css('display', 'inline-block');
        $('div.book-save-chapter').css('display', 'inline-block');
    }

    function editChapter(id) {

        if(need_save == 1 && !confirm('Текущие изменения будут потеряны. Продолжить?')) return false;
        $.post('/booksmanager/get_chapter', {
            item_id: $('#book-item-id').val(),
            id: id
        }).done(function(response) {
            data = $.parseJSON(response);
            if($('div.book-chapter-content').is(":hidden")) addChapter();
            $('#book-chapter-title').val(data.title);
            $('div.book-chapter-content .redactor_textarea').html(data.content);
            $('#book-chapter-id').val(data.chapter_id);
        });
    }

    function cancelChapter(){
        $('div.book-chapter-content').slideUp(0);
        $('#edit_book_menu').show();
        $('div.book-chapters-manager').show();
        $('div.book-chapters').show();
        $('div.book-add-chapter').show();
        $('div.selected-delete').show();
        $('div.header-chapters').show();
        $('#book-chapter-title').val('');
        $('div.book-chapter-content .redactor_textarea').html('');
        $('div.book-cancel-chapter').hide();
        $('div.book-save-chapter').hide();
    }

    function saveChapter(){
        if($('#book-chapter-title').val() == '') return false;
        if($('div.book-chapter-content .redactor_textarea').html() == '') return false;
        $.post('/booksmanager/add_chapter', {
            item_id: $('#book-item-id').val(),
            title: $('#book-chapter-title').val(),
            content: $('div.book-chapter-content .redactor_textarea').html(),
            chapter_id: $('#book-chapter-id').val(),
            author_id: $('#book-author-id').val(),
        }).done(function(response) {
            data = $.parseJSON(response);
            $('div.book-chapters-manager').html(data.message);
            $('#book-id').val(data.book_id);
            $('#book-chapter-id').val(data.chapter_id);
            $('div.book-chapter-content .redactor_textarea').html('');
            $('#book-chapter-title').val('');
            cancelChapter();
        });
        return false;
    }

    function deleteChapter(id){
        if(!confirm('Вы действительно хотите удалить данную главу?')) return false;

        $.post('/booksmanager/delete_chapter', {
            item_id: $('#book-item-id').val(),
            id: id
        }).done(function(response){
            data = $.parseJSON(response);
            $('div.book-chapters-manager').html(data.content);
        });
        return false;
    }

    $('body').on('change', '#del-flag', function(event) {
        to_del = [];
        $('input#del-flag').each(function () {
            if ($(this).is(':checked')) {
                to_del.push($(this).val());
				$(this).closest('div.book-chapter').addClass('select');
            } else {
				$(this).closest('div.book-chapter').removeClass('select');
			}
        });

        if(to_del.length > 0){
            $('div.selected-delete').addClass('active');           
        } else {
            $('div.selected-delete').removeClass('active');           
        }
    });

    $('body').on('click', 'div.selected-delete.active', function(event) {
        event.preventDefault();
        if(!confirm('Вы действительно хотите удалить выбранные главы?')){
            to_del = [];
            $('input#del-flag').each(function () {
                $(this).prop('checked', false);
            });
            $('div.selected-delete.active').removeClass('active');
            $('div.book-chapter.select').removeClass('select');
            return false;
        }
        $.post('/booksmanager/delete_chapters', {
            item_id: $('#book-item-id').val(),
            ids: to_del
        }).done(function(response) {
            data = $.parseJSON(response);
            $('div.book-chapters-manager').html(data.content);
            $('div.selected-delete.active').removeClass('active');
            $('div.book-chapter.select').removeClass('select');
        });
        return false;
    });

    function viewChapter(id){
        $.post('/booksmanager/get_chapter', { id: id, item_id: $('#book-item-id').val()}).done(function(response) {
            data = $.parseJSON(response);
            if(!data.error){
                $('.modal-content').html(data.content);
                $('.modal-title span').html(data.title);
                $('.modal').show();
            }
        });
    }

    function hideModal() {
        $('.modal').hide();
    }

</script>
